VERSION 5.00
Begin VB.Form frmPBExample 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "PropertyBag - Demonstration"
   ClientHeight    =   6120
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6120
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtInhalt 
      Height          =   1575
      Left            =   120
      TabIndex        =   10
      Top             =   4440
      Width           =   4695
   End
   Begin VB.CommandButton cmdWerteAuslesen 
      Caption         =   "Werte &auslesen"
      Height          =   375
      Left            =   2760
      TabIndex        =   8
      Top             =   2760
      Width           =   1935
   End
   Begin VB.CommandButton cmdWertlschen 
      Caption         =   "Wert &lschen"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   3240
      Width           =   2175
   End
   Begin VB.CommandButton cmdWertHinzufgen 
      Caption         =   "Wert &hinzufgen"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   2760
      Width           =   2175
   End
   Begin VB.ListBox lstAusgabe 
      Height          =   1620
      Left            =   2760
      TabIndex        =   5
      Top             =   960
      Width           =   1935
   End
   Begin VB.ListBox lstEingabe 
      Height          =   1620
      Left            =   240
      TabIndex        =   2
      Top             =   960
      Width           =   2055
   End
   Begin VB.Line Line2 
      X1              =   120
      X2              =   4800
      Y1              =   3720
      Y2              =   3720
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Inhalt der PropertyBag"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   3960
      Width           =   4695
   End
   Begin VB.Line Line1 
      X1              =   2520
      X2              =   2520
      Y1              =   120
      Y2              =   3720
   End
   Begin VB.Label Label4 
      Caption         =   "Werte:"
      Height          =   255
      Left            =   2880
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Werte:"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Ausgabe"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   2880
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Eingabe"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   795
   End
End
Attribute VB_Name = "frmPBExample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private MeinePropertyBag   As PropertyBag ' Die PropertyBag, die verwendet wird
Private PBCString          As String      ' Der Inhalt der PropertyBag

Private Sub cmdWerteAuslesen_Click()
   Dim i As Long              ' Um alle Werte in der PropertyBag durchzugehen
   Dim ByteArray() As Byte    ' Wird bentigt, da die PropertyBag keine Strings annimmt
   
   ' lstAusgabe lschen
   Call lstAusgabe.Clear
   
   ' PropertyBag lschen
   Set MeinePropertyBag = New PropertyBag
   
   ' String in ein ByteArray konvertieren
   ByteArray = StrConv(PBCString, vbFromUnicode)
   
   ' ByteArray an die Contents-Eigenschaft der PropertyBag bergeben
   MeinePropertyBag.Contents = ByteArray
   
   ' Sind berhaupt Werte vorhanden?
   If MeinePropertyBag.ReadProperty("AnzahlWerte") = 0 Then
      Call lstAusgabe.AddItem("Keine Werte vorhanden!")
      Exit Sub
   End If
   
   ' Einen Wert nach dem anderen ausgeben
   For i = 0 To MeinePropertyBag.ReadProperty("AnzahlWerte") - 1
      Call lstAusgabe.AddItem(MeinePropertyBag.ReadProperty("Wert" & CStr(i)))
   Next i
End Sub

Private Sub cmdWertHinzufgen_Click()
   Dim Eingabe As String
   
   ' Wert eingeben lassen
   Eingabe = InputBox("Bitte den neuen Wert eingeben:", "Werteingabe")
   
   ' Nur, wenn ein Wert eingegeben wurde, diesen hinzufgen
   If Eingabe <> "" Then
      Call lstEingabe.AddItem(Eingabe)
   End If
   
   ' Aktualisieren
   Call Aktualisieren
End Sub

Private Sub cmdWertlschen_Click()
   ' berprfen, ob ein Wert ausgewhlt ist
   If lstEingabe.ListIndex = -1 Then Exit Sub
   
   ' Den gewhlten Wert lschen
   Call lstEingabe.RemoveItem(lstEingabe.ListIndex)
   
   ' Aktualisieren
   Call Aktualisieren
End Sub

Private Sub Form_Load()
   ' Standard-Werte hinzufgen
   Call lstEingabe.AddItem("Ein Wert")
   Call lstEingabe.AddItem("Noch ein Wert")
   Call lstEingabe.AddItem("Wert Nr. 3")
   Call lstEingabe.AddItem("Wert Nr. 4")
   
   ' Anzeige aktualisieren
   Call Aktualisieren
End Sub

Private Sub Aktualisieren()
   Dim i As Long              ' Um alle Werte in der ListBox durchzugehen
   
   ' PropertyBag lschen
   Set MeinePropertyBag = New PropertyBag
   
   ' Anzahl der Werte schreiben
   Call MeinePropertyBag.WriteProperty("AnzahlWerte", lstEingabe.ListCount)
   
   ' Alle Werte durchlaufen
   For i = 0 To lstEingabe.ListCount - 1
      ' Wert in die PropertyBag schreiben
      Call MeinePropertyBag.WriteProperty("Wert" & CStr(i), lstEingabe.List(i))
   Next i
   
   ' Inhalt der PropertyBag in PBCString kopieren
   '  Hier hilft uns StrConv(), mit dieser Funktion konvertieren wir
   '  das ByteArray aus der Contents-Eigenschaft in einen String.
   '  Ansonsten wrde eine implizite Konvertierung angestellt,
   '  was man aber nach Mglichkeit vermeiden sollte.
   '  Der Preis dafr, dass wir keine implizite Konvertierung haben,
   '  ist, dass wir jedes Mal, wenn wir etwas mit dem Inhalt machen
   '  wollen, diesen wieder zurckkonvertieren mssen.
   PBCString = StrConv(MeinePropertyBag.Contents, vbUnicode)
   
   ' Inhalt der PropertyBag anzeigen
   '  vbNullChar-Zeichen werden als Ende des Strings interpretiert, deswegen
   '  werden diese entfernt und durch Leerzeichen ersetzt...
   '  Dies dient lediglich der Anzeige und sollte nicht bernommen werden.
   '  Hier wird die Konvertierung nach Unicode wieder rckgngig gemacht,
   '  damit der Text nicht zu breit dargestellt wird.
   txtInhalt.Text = Replace(StrConv(PBCString, vbFromUnicode), vbNullChar, " ")
End Sub
